/**
 * @file
 * Provides Slick Browser utilitiy functions.
 */

(function ($, Drupal) {

  'use strict';

  var _onSb = 'sb--on';
  var _onItem = 'sb-item-container--on';
  var _onDetails = 'sb--wrapper-hidden--on';
  var _onMediaRendered = 'media--rendered--on';
  var _elSb = '.sb:not(.' + _onSb + ')';
  var _elItem = '.sb .item-container:not(.' + _onItem + ')';
  var _elDetails = '.sb--wrapper-hidden:not(.' + _onDetails + ')';
  var _elMediaRendered = '.media--rendered:not(.' + _onMediaRendered + ')';

  Drupal.slickBrowser = Drupal.slickBrowser || {};

  /**
   * Attaches Slick Browser common behavior to HTML element.
   *
   * @type {Drupal~behavior}
   */
  Drupal.behaviors.slickBrowser = {
    attach: function (context) {

      var me = Drupal.slickBrowser;
      context = me.context(context);

      me.once(context, _elSb, me.sb);
      me.once(context, _elItem, me.itemContainer);
      me.once(context, _elDetails, me.sbDetails);
      me.once(context, _elMediaRendered, me.sbMediaRendered);
    },
    detach: function (context, setting, trigger) {
      if (trigger === 'unload') {
        $('.sb .item-container', context).find('.button').off('.sbAction');
      }
    }
  };

})(jQuery, Drupal);
